<template>
    <div class="p-3">
        <div class="bg-fff flex1 ov-hd d-flex flex-cln">
            <div class="d-flex a-c pd-16 border-bottom">
                <div class="f-s-20 c-333 f-w-7 mr-10">{{ form.id ? '编辑' : '新增' }}{{ selectDictLabel(new_type, form.newsType) }}</div>
                <el-button @click="router.go(-1)" type="primary" text>
                    <el-icon>
                        <Back />
                    </el-icon>
                    返回上一级
                </el-button>
            </div>
            <div class="flex1 over-auto">
                <el-form ref="formRef" label-width="auto" label-position="top" :model="form" :rules="rules" :disabled="disable">
                    <div class="pd-16 border-bottom ov-hd">
                        <el-row :gutter="90">
                            <el-col :span="8">
                                <el-form-item label="标题：" prop="newsTitle">
                                    <el-input v-model="form.newsTitle" clearable placeholder="请输入标题"></el-input>
                                </el-form-item>
                            </el-col>
                            <el-col :span="8">
                                <el-form-item label="发布时间：" prop="publishTime">
                                    <el-date-picker v-model="form.publishTime" type="datetime" placeholder="选择日期时间" format="YYYY-MM-DD HH:mm:ss" value-format="YYYY-MM-DD HH:mm:ss" :disabled="disable"></el-date-picker>
                                </el-form-item>
                            </el-col>
                            <el-col :span="8">
                                <el-form-item label="来源：" prop="newsOrigin">
                                    <el-input v-model="form.newsOrigin" clearable placeholder="请输入标题"></el-input>
                                </el-form-item>
                            </el-col>
                        </el-row>
                        <el-row>
                            <el-col :span="24">
                                <el-form-item label="文章内容" prop="newsContent">
                                    <div class="flex1">
                                        <Editor v-model="form.newsContent" placeholder="请输入内容"></Editor>
                                    </div>
                                </el-form-item>
                            </el-col>
                        </el-row>
                    </div>
                </el-form>
            </div>
            <div class="d-flex a-c j-c pd-16">
                <el-button @click="router.go(-1)">取消</el-button>
                <template v-if="form.newsStatus !== '1'">
                    <el-button @click="save" color="#0079fe">暂存</el-button>
                    <el-button @click="submitGround" type="warning">立即上架</el-button>
                </template>
                <el-button v-if="form.newsStatus === '1'" @click="save" type="primary">提交</el-button>
            </div>
        </div>
    </div>
</template>

<script setup name="about-input" lang="ts">
import { ref, reactive, onMounted } from 'vue';
import { debounce } from 'lodash';
import { addNews, editNews, publishNews, getNewsInfo } from '@/api/dgtmedicine/news';
import { useRouter } from 'vue-router';
import { AddBtn } from '@/views/models';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { new_type } = toRefs<any>(proxy?.useDict('new_type'));
const router = useRouter();
const form = ref<any>({
    id: undefined,
    newsTitle: '',
    newsContent: '',
    newsImg: '',
    publishTime: '',
    newsOrigin: '',
    newsType: '32'
});
const rules = reactive({
    newsTitle: [{ required: true, message: '请输入标题', trigger: 'blur' }],
    newsContent: [{ required: true, message: '请输入内容', trigger: 'blur' }]
});
const formRef = ref();
const varietyOptions = ref([]);

const save = debounce(async () => {
    await formRef.value.validate();
    const res = form.value.id ? await editNews(form.value) : await addNews(form.value);
    if (res && res.code === 200) {
        proxy.$modal.msgSuccess('操作成功');
    }
}, 500);

const submitGround = debounce(async () => {
    await formRef.value.validate();
    const res = form.value.id ? await editNews(form.value) : await addNews(form.value);
    if (res && res.code === 200) {
        await publishNews(res.data.id);
        proxy.$modal.msgSuccess('发布成功');
    }
}, 500);
const fetchDetail = async (id) => {
    const res = await getNewsInfo(id);
    if (res && res.code === 200) {
        form.value = res.data;
    }
};
const disable = ref(false);
const route = useRoute();
onMounted(() => {
    form.value.newsType = route.query?.newsType;
    if (route.query?.id) {
        // 编辑
        fetchDetail(route.query?.id);
    }
});
</script>
